#! /bin/sh
#
# Script de configuration pour FPAC
# fpac_cfg.sh
#
#    LALANNE Laurent - F5SOH - 01/2000
#
# - f5soh@bigfoot.com - f5soh@f5kbs.faqi.fra.eu -
#
#  v0.1 : premiere version, certainement avec des erreurs... :-)
#
# Vga extended 80x50
# Vga normal 80x25 (avec option -25 au lancement)
#
##################################################################
#
#
#

conf_dir=/etc/ax25
fpac_bin_dir=/usr/local/fpac/bin

dir_script=`dirname $0`
help_dir=/help
doc_html=/doc_html/FPAC-HOWTO.html
dbregion=./db_region_fr.txt

#
#
#
# ****/\/\/\**** Rien a editer apres cette ligne ****/\/\/\****
#
VERSION=0.1
#
# *************************************************************************
#

. $dbregion      # Lecture fichier DB (regions/depts/zone)
l2_ssid=10       # Ssid par defaut (pour l'utilisateur) 
inet_port=1023

#
# Fichiers temporaires
#

rm ports.tmp     # Fichier temporaire pour extraire les ports/call du axports

rm fpac_cfg1.tmp # Pwd, info node, ports / def. port
rm fpac_cfg2.tmp # Commandes node
rm fpac_cfg3.tmp # Alias
rm fpac_cfg4.tmp # Ports FPAC
rm fpac_cfg5.tmp # Nodes adjacents
rm fpac_cfg6.tmp # Entete bloc routage
rm fpac_cfg7.tmp # Routage region
rm fpac_cfg8.tmp # Routage dept
rm fpac_cfg9.tmp # Routage specifique

rm routage_sort.tmp # Fichier de classement des adresses rose (routage)

#
# Ports FPAC
#

id_hf=10     # HF = xxx1xx
id_vhf=20    # VHF = xxx2xx 
id_uhf=30    # UHF = xxx3xx
id_other=40  # SHF = xxx4xx

menu()
{
  while [ 1 ] ; do

    dialog --title "Configuration" \
	   --backtitle "Selection" \
	   --menu " Node FPAC" 22 70 15 \
	   PWD_NODE  "Mot de passe du Node (Sysop)               " \
	   CALL_NODE "Indicatif du node                          " \
	   INFO_NODE "Informations sur le node (locator, ville)  " \
	   ADDRESS   "Adresse ROSE du node                       " \
           PORTS_AX  "Ports radio (selection des ports sous FPAC)" \
	   DEF_PORT  "Selection des ports utilisateurs           " \
           COMMAND   "Commandes du node (edition a partir d'un exemple)" \
           ALIAS     "Indicatifs alias                           " \
	   NODE_ADJ  "Nodes adjacents                            " \
           ROUTAGE   "Routage Rose                               " \
           SEE_CFG   "Voir le fichier de configuration           " \
	   CREATE    "Creer le fichier /etc/ax25/fpac.conf       " \
           DOC_HTML  "Voir la documentation Html (avec lynx)     " \
	   EXIT      "Quitter                                    " \
	   2>/tmp/$$
    if [ ! $? = 0 ] ; then
      return
    fi
    read WHICH < /tmp/$$
    case "$WHICH" in
    DOC_HTML) lynx $dir_script$doc_html;;
    PWD_NODE) dialog --inputbox "Mot de passe du node" \ 8 50 "${pwd_node}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read pwd_node < /tmp/$$
              fi;;
    CALL_NODE) dialog --inputbox "Indicatif du Node (en MAJUSCULES)" \ 8 50 "${node_call}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read node_call < /tmp/$$
              fi
               dialog --inputbox "SSID du node vu par l'utilisateur (8 ou 10)" \ 8 50 "${l2_ssid}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read l2_ssid < /tmp/$$
		l3_ssid=`expr $l2_ssid + 1`
              fi;;
    INFO_NODE) dialog --inputbox "Locator du node" \ 8 50 "${loc_node}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read loc_node < /tmp/$$
              fi
               dialog --inputbox "Emplacement du node (Ville)" \ 8 50 "${city}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read city < /tmp/$$
              fi;;
    ADDRESS) address_node;;
    COMMAND) write_2;;
    PORTS_AX) port_ax25;;
    DEF_PORT) port_user;;
    ALIAS) dialog --inputbox "Quel est l'indicatif local (ex: F6FBB-3)" \ 8 50 "${loc_alias}" 2>/tmp/$$
                if [ $? = 0 ] ; then
                 read loc_alias < /tmp/$$
                fi
           dialog --inputbox "Redirige vers : (entrez le chemin ex: F6KRQ-3,931501)" \ 8 50 "${path_alias}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read path_alias < /tmp/$$
                write_3
              fi;;
    NODE_ADJ) adjacent_node;;
    ROUTAGE) routage;;
    SEE_CFG) routage_sort;;
    CREATE) write_fpac_conf;;
    EXIT) exit;;
	      
    esac
done
}

address_node()
{
while [ 1 ] ; do
     dialog --inputbox "Quel est votre departement ?" \ 8 50 "${dept}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read dept < /tmp/$$
              fi
		line=`grep $dept $dbregion`
		regionpkt=`expr "$line" : "\(....\)"`
		regiontxt=`expr "$line" : ".*/\(.*\)/.*/.*"`
		regionrose=`expr "$line" : ".*/\(.\)"`
     dialog --inputbox "Dans les nodes du Dept, vous etes le Xieme node, entrer la valeur 'X'" \ 8 50 "${no}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read no < /tmp/$$
              fi
	        addr_rose="$DNIC,$regionrose${dept}50${no}"
     dialog --title "Resultat" \
            --beep \
            --msgbox " \n  Votre adresse Rose est :  \n\n        $addr_rose    \n\n   Region      : $regionpkt       \n   Departement : $dept  " 12 35 
menu
done

}

port_ax25()
{
while [ 1 ] ; do

    dialog --title "Configuration / selection des ports visibles par FPAC" \
	   --backtitle "Selection" \
	   --menu " Ports disponibles actuellement (8 maximum)" 16 60 10 \
	   PORT1 "1er port  : $port1  ($call1)" \
	   PORT2 "2eme port : $port2  ($call2)" \
	   PORT3 "3eme port : $port3  ($call3)" \
	   PORT4 "4eme port : $port4  ($call4)" \
	   PORT5 "5eme port : $port5  ($call5)" \
	   PORT6 "6eme port : $port6  ($call6)" \
	   PORT7 "7eme port : $port7  ($call7)" \
	   PORT8 "8eme port : $port8  ($call8)" \
	   HELP "Aide sur les ports (configuration / selection)" \
	   EXIT "Retour menu precedent" \
	   2>/tmp/$$
    if [ ! $? = 0 ] ; then
      return
    fi
    read WHICH < /tmp/$$
    case "$WHICH" in
           PORT1) no=1
	          port_fpac;;
	   PORT2) no=2
	          port_fpac;;
           PORT3) no=3
	          port_fpac;;
           PORT4) no=4
	          port_fpac;;
           PORT5) no=5
	          port_fpac;;
           PORT6) no=6
	          port_fpac;;
           PORT7) no=7
	          port_fpac;;
           PORT8) no=8
	          port_fpac;;
           HELP) dialog --title "Aide sur la configuration / selection des ports" \
                        --backtitle "Lire..." \
                        --textbox ${help_dir}/Readme.port $LINE 80 ;;
           EXIT) menu;;
    esac
done
}

port_user()
{
while [ 1 ] ; do
     dialog --title " Ports utilisateurs" \
            --checklist "Selectionner les ports accessibles aux utilisateurs:" 15 60 4 \
	    "$port1" " 1er  port  " off \
	    "$port2" " 2eme port  " off \
	    "$port3" " 3eme port  " off \
	    "$port4" " 4eme port  " off \
	    "$port5" " 5eme port  " off \
	    "$port6" " 6eme port  " off \
	    "$port7" " 7eme port  " off \
	    "$port8" " 8eme port  " off \
	    2> /tmp/$$
            read WHICH < /tmp/$$
            usr_port=$WHICH
	    user_ports="`echo $usr_port | tr -d "\042"`"
	    
    dialog --title "Info" \
           --infobox "     Ports disponibles pour l'utilisateur : \n \n $user_ports" 10 50
sleep 1
    dialog --title "Port FPAC par defaut" \
	   --radiolist "Selectionner le port par defaut" 14 40 8 \
	   "$port1" "" off \
	   "$port2" "" off \
	   "$port3" "" off \
	   "$port4" "" off \
	   "$port5" "" off \
	   "$port6" "" off \
	   "$port7" "" off \
	   "$port8" "" off \
	   2>/tmp/$$
    read WHICH < /tmp/$$
    def_port=$WHICH
    dialog --title "Info" \
           --infobox "\n Port par defaut: $def_port" 10 40
sleep 1
write_1
done
}


port_fpac()
{
while [ 1 ] ; do
     dialog --inputbox "Quel nom donnez-vous a ce port (port$no) sous FPAC (declaration des ports) ? \n
 Exemple VHF, UHF1, UHF2 etc ... (en majuscules)." \ 8 80 "${name_port_fpac}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read name_port_fpac < /tmp/$$
	      fi	
     dialog --menu "Type de port :" 15 60 4 \
	    PORT_HF  "Port en HF (deca)" \
	    PORT_VHF "Port en VHF (144)" \
	    PORT_UHF "Port en UHF (432)" \
	    OTHER    "Autre (SHF,LAN ?)" \
	    2>/tmp/$$
	if [ $? = 0 ] ; then    
        read WHICH < /tmp/$$
	fi
	case "$WHICH" in
            PORT_HF) id_hf=$id_hf + 1
	             id_port=$id_hf
		     write_4;;
	    PORT_VHF) id_vhf=$id_vhf + 1
	              id_port=$id_vhf
		      write_4;;
            PORT_UHF) id_uhf=$id_uhf + 1
	              id_port=$id_uhf
		      write_4;;
	    OTHER) id_other=$id_other + 1
	           id_port=$id_other
		   write_4;;
     esac
done

}

adjacent_node()
{
while [ 1 ] ; do
dnic_adj=$DNIC
     dialog --inputbox "Quel nom pour le node adjacent ? ex: bordeaux, toulouse (utilise pour le routage)" \ 8 50 "${node_name}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read node_name < /tmp/$$
              fi
     dialog --inputbox "  Quel est son indicatif L3 (F5XYZ-11 ou -9)\n               (en MAJUSCULES)" \ 8 50 "${call_l3_adj}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read call_l3_adj < /tmp/$$
              fi
     dialog --inputbox "Quel est son DNIC (2080 pour la France)" \ 8 50 "${dnic_adj}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read dnic_adj < /tmp/$$
              fi
     dialog --inputbox "Quel est son adresse Rose ? (ex: 833504)" \ 8 50 "${addr_adj}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read addr_adj < /tmp/$$
              fi
    dialog --title "Selection du port" \
	   --radiolist "Selectionner le port pour ce node adjacent (fleches + touche <Espace>)" 18 50 8 \
	   "$port1" "" off \
	   "$port2" "" off \
	   "$port3" "" off \
	   "$port4" "" off \
	   "$port5" "" off \
	   "$port6" "" off \
	   "$port7" "" off \
	   "$port8" "" off \
	   2>/tmp/$$
    read port_adj < /tmp/$$
     dialog --menu "Ce node accepte d'echanger les Whites Pages ?"  10 50 2 \
         OUI ", il echange les WP" \
	 NON ", pas d'echange (ex: FPAC Dos)" 2> /tmp/$$
           if [ $? = 0 ] ; then
         read WHICH < /tmp/$$
           if [ "$WHICH" = "OUI" ] ; then
	 wp_adj_aff="Oui"
	 wp_adj="0"
	   else
	 wp_adj_aff="Non"
	 wp-adj="1"
	   fi
	   fi
     dialog --title "Resultat" \
            --beep \
            --menu " \n  Vous avez declare le node adjacent suivant :  \n
      Nom pour le routage : $node_name
      Indicatif L3        : $call_l3_adj
      Adresse Rose        : $dnic_adj,$addr_adj
      Port de connexion   : $port_adj
      Echange des WP      : $wp_adj_aff\n
        
                     " 20 60 4 \
	 ANNULE    " Annule le node en cours, retour au menu" \
         RETURN    " Corriger les donnees" \
	 ADD_NODE  " Ajouter un autre node adjacent" \
	 MENU      " Retour au menu principal (fin)" 2> /tmp/$$
           if [ $? = 0 ] ; then
         read WHICH < /tmp/$$
           fi
	case "$WHICH" in
	    ANNULE) menu;;
            RETURN) adjacent_node;;
	    ADD_NODE) write_5;;
	    MENU) write_5;;
        esac
done
}

routage()
{
  while [ 1 ] ; do

    dialog --title "Routage FPAC" \
	   --backtitle "Selection" \
	   --menu " Routage des regions / departements" 20 65 14 \
	   HELP_ROUTAGE "Informations sur le routage" \
	   ROUT_REGION  "Routage des regions" \
	   ROUT_DEPT    "Routage des departements" \
	   ROUT_SPEC    "Autre routage" \
	   RETURN       "Retour menu principal" \
	   2>/tmp/$$
    if [ ! $? = 0 ] ; then
      return
    fi
    read WHICH < /tmp/$$
    case "$WHICH" in
    HELP_ROUTAGE) dialog --title "Aide sur le menu routage" \
                         --backtitle "Lire..." \
                         --textbox ${help_dir}/Readme.routage $LINE 80 ;;
    ROUT_REGION) routage_region;;
    ROUT_DEPT) routage_dept;;
    ROUT_SPEC) routage_spec;;
    RETURN) menu;;
    esac
done
}

routage_region()
{ 	      
while [ 1 ] ; do
     dialog --title " Routage simple des regions" \
            --radiolist "Selectionner une zone packet pouvant etre routee juste avec l'identifiant de region (1er digit):" 20 60 9 \
	    "1" " FRPA            " off \
	    "2" " FNPP            " off \
	    "3" " FRBE, FNOR      " off \
	    "4" " FCEN, FPDL      " off \
	    "5" " FALI            " off \
	    "6" " FBFC, FCAL      " off \
	    "7" " FCOR FPCA FRHA  " off \
	    "8" " FAQI FPOC       " off \
	    "9" " FMLR            " off 2> /tmp/$$
            read id_region < /tmp/$$

nodes_names="`grep "Node =" fpac_cfg5.tmp | tr -d "=" | awk '{ print $2 " " $4 " " $6 " " $8 " " $10 " " $12 }'`"
node_name1="`echo $nodes_names | awk '{ print $1 }'`"
node_name2="`echo $nodes_names | awk '{ print $2 }'`"
node_name3="`echo $nodes_names | awk '{ print $3 }'`"
node_name4="`echo $nodes_names | awk '{ print $4 }'`"
node_name5="`echo $nodes_names | awk '{ print $5 }'`"
node_name6="`echo $nodes_names | awk '{ print $6 }'`"
vide="`echo $nodes_names | awk '{ print $30 }'`"

vid_txt="???"
if [ "$node_name1" = "$vide" ] ; then
node_name1="$vid_txt"
fi
if [ "$node_name2" = "$vide" ] ; then
node_name2="$vid_txt"
fi
if [ "$node_name3" = "$vide" ] ; then
node_name3="$vid_txt"
fi
if [ "$node_name4" = "$vide" ] ; then
node_name4="$vid_txt"
fi
if [ "$node_name5" = "$vide" ] ; then
node_name5="$vid_txt"
fi
if [ "$node_name6" = "$vide" ] ; then
node_name6="$vid_txt"
fi
if [ "$node_name1" = "$vide" ] ; then
node_name1="Vide"
fi
if [ "$node_name1" = "$vide" ] ; then
node_name1="Vide"
fi

nodes_path="`grep "Path     =" fpac_cfg5.tmp | tr -d "=" | awk '{ print $2 " " $4 " " $6 " " $8 " " $10 " " $12 }'`"
path1="`echo $nodes_path | awk '{ print $1 }'`"
path2="`echo $nodes_path | awk '{ print $2 }'`"
path3="`echo $nodes_path | awk '{ print $3 }'`"
path4="`echo $nodes_path | awk '{ print $4 }'`"
path5="`echo $nodes_path | awk '{ print $5 }'`"
path6="`echo $nodes_path | awk '{ print $6 }'`"

     dialog --title "Node adjacent" \
            --radiolist "Selectionner le nom du node adjacent pour le routage de la region $id_region :" 20 60 6 \
            "$node_name1" "$path1   " off \
            "$node_name2" "$path2   " off \
            "$node_name3" "$path3   " off \
            "$node_name4" "$path4   " off \
	    "$node_name5" "$path5   " off \
	    "$node_name6" "$path6   " off 2> /tmp/$$
            read node_route < /tmp/$$
     if [ "$node_route" = "$vid_txt" ] ; then
     routage_region
     fi
     dialog --title "Resultat" \
            --beep \
            --menu " \n  Vous avez declare le routage suivant :  \n
      Region       : $id_region \n      Node         : $node_route\n
 Toutes les adresses de type ${id_region}xxxxx seront \n routees sur $node_route !
                     " 20 60 3 \
         RETURN     " Corriger les donnees" \
	 ADD_ROUTE  " Ajouter un autre routage de region" \
	 MENU       " Retour au menu routage" \
	 2> /tmp/$$
           if [ $? = 0 ] ; then
         read WHICH < /tmp/$$
           fi
	case "$WHICH" in
            RETURN) routage_region;;
	    ADD_ROUTE) write_6;;
	    MENU) write_6;;
        esac
done
}

routage_dept()
{
while [ 1 ] ; do
dnic_adj=$DNIC
     dialog --inputbox "Quel numero de departement (2 caractereres) ? ex: 01" \ 8 50 "${dept_num}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read dept_num < /tmp/$$
              fi
line=`grep $dept_num $dbregion`
id_region=`expr "$line" : ".*/\(.\)"`

nodes_names="`grep "Node =" fpac_cfg5.tmp | tr -d "=" | awk '{ print $2 " " $4 " " $6 " " $8 " " $10 " " $12 }'`"
node_name1="`echo $nodes_names | awk '{ print $1 }'`"
node_name2="`echo $nodes_names | awk '{ print $2 }'`"
node_name3="`echo $nodes_names | awk '{ print $3 }'`"
node_name4="`echo $nodes_names | awk '{ print $4 }'`"
node_name5="`echo $nodes_names | awk '{ print $5 }'`"
node_name6="`echo $nodes_names | awk '{ print $6 }'`"
vide="`echo $nodes_names | awk '{ print $30 }'`"

vid_txt="???"
if [ "$node_name1" = "$vide" ] ; then
node_name1="$vid_txt"
fi
if [ "$node_name2" = "$vide" ] ; then
node_name2="$vid_txt"
fi
if [ "$node_name3" = "$vide" ] ; then
node_name3="$vid_txt"
fi
if [ "$node_name4" = "$vide" ] ; then
node_name4="$vid_txt"
fi
if [ "$node_name5" = "$vide" ] ; then
node_name5="$vid_txt"
fi
if [ "$node_name6" = "$vide" ] ; then
node_name6="$vid_txt"
fi
if [ "$node_name1" = "$vide" ] ; then
node_name1="Vide"
fi
if [ "$node_name1" = "$vide" ] ; then
node_name1="Vide"
fi

nodes_path="`grep "Path     =" fpac_cfg5.tmp | tr -d "=" | awk '{ print $2 " " $4 " " $6 " " $8 " " $10 " " $12 }'`"
path1="`echo $nodes_path | awk '{ print $1 }'`"
path2="`echo $nodes_path | awk '{ print $2 }'`"
path3="`echo $nodes_path | awk '{ print $3 }'`"
path4="`echo $nodes_path | awk '{ print $4 }'`"
path5="`echo $nodes_path | awk '{ print $5 }'`"
path6="`echo $nodes_path | awk '{ print $6 }'`"

     dialog --title "Node adjacent" \
            --radiolist "Selectionner le nom du node adjacent pour le routage du dept $dept_num :" 20 60 6 \
            "$node_name1" "$path1   " off \
            "$node_name2" "$path2   " off \
            "$node_name3" "$path3   " off \
            "$node_name4" "$path4   " off \
	    "$node_name5" "$path5   " off \
	    "$node_name6" "$path6   " off 2> /tmp/$$
            read node_route < /tmp/$$
     if [ "$node_route" = "$vid_txt" ] ; then
     routage_dept
     fi
test -s fpac_cfg7.tmp
if [ $? = 1 ] ; then
     dialog --title "Attention !!!!!" \
            --beep \
            --infobox "\n  N'oubliez pas de faire le routage des regions !!!" 10 60
sleep 2
fi
     dialog --title "Resultat" \
            --beep \
            --menu " \n  Vous avez declare le routage suivant :  \n
      Region       : $id_region \n      Departement  : $dept_num \n      Node         : $node_route\n
 Toutes les adresses de type ${id_region}${dept_num}xxx seront \n routees sur $node_route !
                     " 20 60 3 \
         RETURN     " Corriger les donnees" \
	 ADD_ROUTE  " Ajouter un autre routage de dept" \
	 MENU       " Retour au menu routage" \
	 2> /tmp/$$
           if [ $? = 0 ] ; then
         read WHICH < /tmp/$$
           fi
	case "$WHICH" in
            RETURN) routage_dept;;
	    ADD_ROUTE) write_8;;
	    MENU) write_8;;
        esac
done
}


routage_spec()
{
while [ 1 ] ; do
dnic_adj=$DNIC
     dialog --inputbox "Entrez un routage specifique devant etre route ex: 931204" \ 8 50 "${route_spec}" 2>/tmp/$$
              if [ $? = 0 ] ; then
                read route_spec < /tmp/$$
              fi

nodes_names="`grep "Node =" fpac_cfg5.tmp | tr -d "=" | awk '{ print $2 " " $4 " " $6 " " $8 " " $10 " " $12 }'`"
node_name1="`echo $nodes_names | awk '{ print $1 }'`"
node_name2="`echo $nodes_names | awk '{ print $2 }'`"
node_name3="`echo $nodes_names | awk '{ print $3 }'`"
node_name4="`echo $nodes_names | awk '{ print $4 }'`"
node_name5="`echo $nodes_names | awk '{ print $5 }'`"
node_name6="`echo $nodes_names | awk '{ print $6 }'`"
vide="`echo $nodes_names | awk '{ print $30 }'`"

vid_txt="???"
if [ "$node_name1" = "$vide" ] ; then
node_name1="$vid_txt"
fi
if [ "$node_name2" = "$vide" ] ; then
node_name2="$vid_txt"
fi
if [ "$node_name3" = "$vide" ] ; then
node_name3="$vid_txt"
fi
if [ "$node_name4" = "$vide" ] ; then
node_name4="$vid_txt"
fi
if [ "$node_name5" = "$vide" ] ; then
node_name5="$vid_txt"
fi
if [ "$node_name6" = "$vide" ] ; then
node_name6="$vid_txt"
fi
if [ "$node_name1" = "$vide" ] ; then
node_name1="Vide"
fi
if [ "$node_name1" = "$vide" ] ; then
node_name1="Vide"
fi

nodes_path="`grep "Path     =" fpac_cfg5.tmp | tr -d "=" | awk '{ print $2 " " $4 " " $6 " " $8 " " $10 " " $12 }'`"
path1="`echo $nodes_path | awk '{ print $1 }'`"
path2="`echo $nodes_path | awk '{ print $2 }'`"
path3="`echo $nodes_path | awk '{ print $3 }'`"
path4="`echo $nodes_path | awk '{ print $4 }'`"
path5="`echo $nodes_path | awk '{ print $5 }'`"
path6="`echo $nodes_path | awk '{ print $6 }'`"

     dialog --title "Node adjacent" \
            --radiolist "Selectionner le node adjacent pour le routage de $route_spec :" 20 60 6 \
            "$node_name1" "$path1   " off \
            "$node_name2" "$path2   " off \
            "$node_name3" "$path3   " off \
            "$node_name4" "$path4   " off \
	    "$node_name5" "$path5   " off \
	    "$node_name6" "$path6   " off 2> /tmp/$$
            read node_route_spec < /tmp/$$
     if [ "$node_route_spec" = "$vid_txt" ] ; then
     routage_spec
     fi
test -s fpac_cfg7.tmp
if [ $? = 1 ] ; then
     dialog --title "Attention !!!!!" \
            --beep \
            --infobox "\n  N'oubliez pas de faire le routage des regions !!!" 10 60
sleep 2
fi
     dialog --title "Resultat" \
            --beep \
            --menu " \n  Vous avez declare le routage suivant :  \n
      Adresse      : $route_spec\n        Node         : $node_route_spec \n
 Les adresses de Rose $route_spec seront \n routees sur $node_route_spec !
                     " 20 60 3 \
         RETURN     " Corriger les donnees" \
	 ADD_ROUTE  " Ajouter un autre routage specifique" \
	 MENU       " Retour au menu routage" \
	 2> /tmp/$$
           if [ $? = 0 ] ; then
         read WHICH < /tmp/$$
           fi
	case "$WHICH" in
            RETURN) routage_spec;;
	    ADD_ROUTE) write_9;;
	    MENU) write_9;;
        esac
done
}


###############################################
#
# Ecriture du fichier de configuration fpac.conf par blocs
#
# write_1 : Tete de fichier + infos node + ports user + defaut port
# write_2 : Commandes node
# write_3 : Alias
# write_4 : Declaration des ports pour FPAC (FPAC <-> Ax25)
# write_5 : Declaration des nodes adjacents
# write 6 : Entete bloc routage
# write_7 : Routage region (1er digit) Xxxxxx
# write_8 : Routage departements (3 premiers digits) XXXxxx
#
###############################################

write_1()
{
while [ 1 ] ; do
echo "\
#
# Fichier de configuration FPAC
# 
# Ce fichier doit etre place dans /etc/ax25/fpac.conf
#

#
# Mot de passe Sysop
#

Password = $pwd_node

#
# Informations sur le node
#
L2call    = $node_call-$l2_ssid
L3call    = $node_call-$l3_ssid
DNIC      = $DNIC
InetPort  = $inet_port
Address   = $regionrose${dept}50${no}
City      = $city
Locator   = $loc_node
#
#
# Ports utilisables par les utilisateurs (connexions L2)
#

UserPort  = $user_ports

# 
# Port par defaut
#

DefPort   = $def_port

" > fpac_cfg1.tmp
menu
done
}

write_2()
{
test -s fpac_cfg1.tmp
if [ $? = 1 ] ; then
     dialog --title "Attention !!!!!" \
            --beep \
            --infobox "\n   Vous devez declarer les informations sur le node,\n   les ports, etc....  avant !" 10 60
sleep 3
menu
fi
test -s fpac_cfg2.tmp
if [ $? = 1 ] ; then
echo "\
#
# Ajout de commandes suplementaires dans le menu du node
#
Command
        CLu = connect ${node_call}-3 $DNIC$regionrose${dept}50${no}
        BBs = connect ${node_call}-1 $DNIC$regionrose${dept}50${no}
        Wp  = ${fpac_bin_dir}/wpserv %*
	WEdit = ${fpac_bin_dir}/wpedit %*
	COnf = /usr/sbin/convers
End

#
# Ajout de commandes pour le Sysop
#
Sysop
        YGET = /usr/sbin/yapp -u /etc/ax25/%1
	YPUT = /usr/sbin/yapp -d /etc/ax25/%1
	LS   = /bin/ls -l /etc/ax25/%1
	CAT  = /bin/cat /etc/ax25/%1
	SYsop = ${fpac_bin_dir}/fpacshell
End" > fpac_cfg2.tmp
mcedit fpac_cfg2.tmp
menu
else
mcedit fpac_cfg2.tmp
menu
fi
}


###############################################

write_3()
{
test -s fpac_cfg3.tmp
if [ $? = 1 ] ; then
echo "\
#
# Liste des alias. Facilite une connexion distante avec un indicatif 
# predefini. ex: F6FBB-3 en local redirige vers F6KRQ-3,931501
#
Alias = $loc_alias
        Path = $path_alias
End" > fpac_cfg3.tmp
else
echo "\
Alias = $loc_alias
        Path = $path_alias
End" >> fpac_cfg3.tmp
fi
menu
}

###############################################

write_4()
{
while [ 1 ] ; do
if [ "$no" = "1" ] ; then
axport=$port1
fi 
if [ "$no" = "2" ] ; then
axport=$port2
fi 
if [ "$no" = "3" ] ; then
axport=$port3
fi 
if [ "$no" = "4" ] ; then
axport=$port4
fi 
if [ "$no" = "5" ] ; then
axport=$port5
fi 
if [ "$no" = "6" ] ; then
axport=$port6
fi 
if [ "$no" = "7" ] ; then
axport=$port7
fi 
if [ "$no" = "8" ] ; then
axport=$port8
fi 
test -s fpac_cfg4.tmp
if [ $? = 1 ] ; then
echo "\
#
# Declaration des ports sous Fpac
#

AddPort   = $name_port_fpac
        Address = $regionrose${dept}$id_port${no}
	Port = $axport
End
" > fpac_cfg4.tmp
else
echo "\
AddPort   = $name_port_fpac
        Address = $regionrose${dept}$id_port${no}
	Port = $axport
End
" >> fpac_cfg4.tmp
fi
port_ax25
done
} 

###############################################

write_5()
{

test -s fpac_cfg5.tmp
if [ $? = 1 ] ; then
echo "\
#
# Declaration des nodes adjacents
#

Node = $node_name
        Path     = $call_l3_adj
	DNIC     = $dnic_adj
	Address  = $addr_adj
	Port     = $port_adj  
	NoWp     = $wp_adj
End" > fpac_cfg5.tmp
else
echo "\

Node = $node_name
        Path     = $call_l3_adj
	DNIC     = $dnic_adj
	Address  = $addr_adj
	Port     = $port_adj  
	NoWp     = $wp_adj
End" > fpac_cfg5.tmp
fi
       if [ "$WHICH" = "MENU" ] ; then
	   menu
       else
           adjacent_node
       fi
} 

##############################################

write_6()
{
test -s fpac_cfg6.tmp
if [ $? = 1 ] ; then
echo "\
#
# Routes vers les nodes adjacents
# 
# DNIC definit le DNIC par defaut pour les adresses qui suivent
# 
#  L'adresse comporte 1 a 6 digits, de maniere hierarchique.
#
Routes
        DNIC=$DNIC" > fpac_cfg6.tmp
write_7
else
write_7
fi
}

###############################################

write_7()
{
echo "\
	$id_region = $node_route" >> fpac_cfg7.tmp

   if [ "$WHICH" = "MENU" ] ; then
   routage
   else
   routage_region
   fi
} 

##############################################

write_8()
{

echo "\
	${id_region}${dept_num} = $node_route" >> fpac_cfg8.tmp

if [ "$WHICH" = "MENU" ] ; then
   routage
else
   routage_dept
fi
}

##############################################

write_9()
{

echo "\
	${route_spec} = $node_route_spec" >> fpac_cfg9.tmp

if [ "$WHICH" = "MENU" ] ; then
   routage
else
   routage_spec
fi
}

###############################################


routage_sort()
{
cat fpac_cfg8.tmp >> fpac_cfg7.tmp
cat fpac_cfg9.tmp >> fpac_cfg7.tmp
sort -n +0 -1 fpac_cfg7.tmp > routage_sort.tmp
see_all
}

###############################################

see_all()
{
cat fpac_cfg1.tmp > fpac.conf.tmp
cat fpac_cfg2.tmp >> fpac.conf.tmp
cat fpac_cfg3.tmp >> fpac.conf.tmp
cat fpac_cfg4.tmp >> fpac.conf.tmp
cat fpac_cfg5.tmp >> fpac.conf.tmp
cat fpac_cfg6.tmp >> fpac.conf.tmp
cat routage_sort.tmp >> fpac.conf.tmp
echo "\
End">> fpac.conf.tmp
mcedit fpac.conf.tmp
menu
}

##############################################

write_fpac_conf()
{
test -s fpac.conf.tmp
if [ $? = 1 ] ; then
     dialog --title "Erreur !!!!!" \
            --beep \
            --infobox "\n  Verifiez le fichier cree avant !!!" 10 60
sleep 2
menu
else
cp fpac.conf.tmp ${conf_dir}/fpac.conf

     dialog --title "Information" \
            --beep \
            --infobox "\n   Le fichier fpac.conf a ete enregistre dans $conf_dir" 10 60
sleep 3
menu
fi
}



sort_port()
{
grep 00 /etc/ax25/axports | awk '{ print NR , ":" $1 ":" $2 }' > ports.tmp
for i in 1 2 3 4 5 6 7 8 ; do
port_line=`grep -s "$i :" ports.tmp`
vide="`echo $port_line | awk '{ print $30 }'`"
vid_txt="???"

echo " "
port=`expr "$port_line" : ".*:\(.*\):.*"`
call=`expr "$port_line" : ".*:.*:\(.*\)"`

if [ "$port" = "$vide" ] ; then
port="$vid_txt"
call="$vid_txt"
fi

if [ "$i" =  "1" ] ; then
port1="$port"
call1="$call"
fi
if [ "$i" =  "2" ] ; then
port2="$port"
call2="$call"
fi
if [ "$i" =  "3" ] ; then
port3="$port"
call3="$call"
fi
if [ "$i" =  "4" ] ; then
port4="$port"
call4="$call"
fi
if [ "$i" =  "5" ] ; then
port5="$port"
call5="$call"
fi
if [ "$i" =  "6" ] ; then
port6="$port"
call6="$call"
fi
if [ "$i" =  "7" ] ; then
port7="$port"
call7="$call"
fi
if [ "$i" =  "8" ] ; then
port8="$port"
call8="$call"
fi
done
rm ports.tmp
menu
}

#
# ---ENTREE-----------------------------------------------------------------
#

LINE=45
VIDE=


  while [ 1 ] ; do

dialog --title "Fpaccfg" \
       --backtitle "- Ecrit par Laurent Lalanne - f5soh@bigfoot.com" \
       --infobox "\n        Fpac_cfg  $VERSION\n
               \n  Programme de configuration \n            FPAC\n       ecrit par F5SOH \n\n    Version $VERSION - 01/2000" 13 35
sleep 2     
LINE=45

while test $1  ; do

    case "$1" in
    
    -h|--help)
      echo " "
      echo "Usage:fpaccfg.sh [-25] Selection du mode vga 25 lignes (defaut 50 lignes)"
      echo "                [-v] version "
      echo "                [-h|--help] cette aide"
      echo " "
      exit 0 ;;
    -v) echo " "
        echo "FPAC_cfg v $VERSION"
        echo " " 
      exit 0 ;;
    -25) LINE=22
         sort_port ;;
    esac
done
sort_port
done

